/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controldeasistencias.utils;

import controldeasistencias.controllers.UsuarioJpaController;
import java.awt.HeadlessException;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceException;
import javax.swing.JOptionPane;
import persistence.util.JpaUtil;

/**
 *
 * @author Eduardo
 */
public class BDConfig extends javax.swing.JDialog {

    String servidor;
    String usuario;
    String clave;
    String bd;
    private static boolean conectado = false;
    private EncryptedProperties prop;
    private EntityManagerFactory emf;

    /**
     * Creates new form BDConfig
     *
     * @param parent
     * @param modal
     */
    public BDConfig(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        this.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(java.awt.event.WindowEvent e) {
                //si al cerrar la ventana  no se ha conectado con la base de datos
                //cerrar la aplicacion
                if (!conectado) {
                    System.exit(0);
                }
            }
        });

        try {
            prop = new EncryptedProperties("xProperti");

        } catch (Exception ex) {
            Logger.getLogger(BDConfig.class.getName()).log(Level.SEVERE, null, ex);
        }

        InputStream input = null;

        try {
            File f = new File("myProperties");
            if (f.exists()) {
                FileInputStream in = new FileInputStream(f);
                prop.load(in);

                String keyURL = "javax.persistence.jdbc.url";
                String keyUser = "javax.persistence.jdbc.user";
                String keyPass = "javax.persistence.jdbc.password";

                String valUser = prop.getProperty("user");
                String valPass = prop.getProperty("pass");
                String valUrl = "jdbc:mysql://" + prop.getProperty("serv") + "/" + prop.getProperty("bd");

                Map<String, Object> properties = new HashMap();
                properties.put(keyURL, valUrl);
                properties.put(keyUser, valUser);
                properties.put(keyPass, valPass);

                this.txtBD.setText(prop.getProperty("bd"));
                this.txtClave.setText(valPass);
                this.txtUsuario.setText(valUser);
                this.txtServidor.setText(prop.getProperty("serv"));
                try {
                    emf = JpaUtil.getEntityManagerFactory(properties);
                    System.out.println("Conexion establecida.");
                } catch (PersistenceException e) {
                    JOptionPane.showMessageDialog(rootPane, "No se ha conectado con "
                            + "la base de datos...", "Message", JOptionPane.ERROR_MESSAGE);
                }
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(BDConfig.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(BDConfig.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

        /**
         * This method is called from within the constructor to initialize the
         * form. WARNING: Do NOT modify this code. The content of this method is
         * always regenerated by the Form Editor.
         */
        @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txtServidor = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtUsuario = new javax.swing.JTextField();
        txtBD = new javax.swing.JTextField();
        btnProbar = new javax.swing.JButton();
        bntAceptar = new javax.swing.JButton();
        txtClave = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Configuración BD");

        jLabel1.setText("Servidor:");

        jLabel2.setText("Usuario:");

        jLabel3.setText("Clave:");

        jLabel4.setText("Base de Datos:");

        btnProbar.setText("Probar");
        btnProbar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnProbarActionPerformed(evt);
            }
        });

        bntAceptar.setText("Guardar");
        bntAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntAceptarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(44, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnProbar, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bntAceptar))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txtServidor)
                            .addComponent(txtUsuario)
                            .addComponent(txtBD, javax.swing.GroupLayout.DEFAULT_SIZE, 146, Short.MAX_VALUE)
                            .addComponent(txtClave))))
                .addContainerGap(38, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtServidor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtClave, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(txtBD, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnProbar)
                    .addComponent(bntAceptar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnProbarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnProbarActionPerformed
        // TODO add your handling code here:
        servidor = txtServidor.getText().trim();
        usuario = txtUsuario.getText().trim();
        clave = txtClave.getText().trim();
        bd = txtBD.getText().trim();

        String keyURL = "javax.persistence.jdbc.url";
        String keyUser = "javax.persistence.jdbc.user";
        String keyPass = "javax.persistence.jdbc.password";

        String valUrl = "jdbc:mysql://" + servidor + "/" + bd;

        Map<String, Object> properties = new HashMap();
        properties.put(keyURL, valUrl);
        properties.put(keyUser, usuario);
        properties.put(keyPass, clave);

        try {

            JpaUtil.getEntityManagerFactory(properties);
            if (testResultFromDB()) {
                JOptionPane.showMessageDialog(rootPane, "Se ha conectado correctamente.", "Message",
                        JOptionPane.INFORMATION_MESSAGE);
                conectado = true;
            } else {
                conectado = false;
                JOptionPane.showMessageDialog(rootPane, "No se ha podido conectar. "
                        + "Asegúrese de colocar los datos correctos. \n"
                        + "Si el problema persiste, contacte con el Administrador "
                        + "de Sistemas.",
                        "Message", JOptionPane.INFORMATION_MESSAGE);
            }
        } catch (HeadlessException e) {
            JOptionPane.showMessageDialog(rootPane, "No se ha conectado con "
                    + "la base de datos...", "Message", JOptionPane.ERROR_MESSAGE);
            utils.LogUtility.writeToErrorLog(e.getMessage());
        }

    }//GEN-LAST:event_btnProbarActionPerformed

    private void bntAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntAceptarActionPerformed
        // TODO add your handling code here:
        servidor = txtServidor.getText().trim();
        usuario = txtUsuario.getText().trim();
        clave = txtClave.getText().trim();
        bd = txtBD.getText().trim();
        try {
            File f = new File("myProperties");
            EncryptedProperties ep = new EncryptedProperties("xProperti");
            try {
                if (f.exists()) {
                    FileInputStream in = new FileInputStream(f);
                    ep.load(in);
                }

                BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
                String key = null;

                ep.setProperty("user", usuario);
                ep.setProperty("pass", clave);
                ep.setProperty("bd", bd);
                ep.setProperty("serv", servidor);

                FileOutputStream out = new FileOutputStream(f);
                ep.store(out, "Encrypted Properties File");
                out.close();
                JOptionPane.showMessageDialog(rootPane, "Se ha creado la configuracion correctamente.", "Message", JOptionPane.INFORMATION_MESSAGE);

            } catch (Exception e) {
                System.out.println("Couldn't access encrypted properties file: " + f.getAbsolutePath());
                e.printStackTrace();
            }
        } catch (Exception e) {
        }
    }//GEN-LAST:event_bntAceptarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(BDConfig.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(BDConfig.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(BDConfig.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BDConfig.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                BDConfig dialog = new BDConfig(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    private static boolean testResultFromDB() {
        boolean testConnection = false;
        try {
            UsuarioJpaController controller = new UsuarioJpaController(JpaUtil.getEntityManagerFactory());
            int resultados = controller.getUsuarioCount();
            if (resultados >= 0) {
                testConnection = true;
            }
        } catch (Exception ex) {
            //si detecta algun error es porque no se ha podido conectar
            testConnection = false;
        }
        return testConnection;
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bntAceptar;
    private javax.swing.JButton btnProbar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField txtBD;
    private javax.swing.JPasswordField txtClave;
    private javax.swing.JTextField txtServidor;
    private javax.swing.JTextField txtUsuario;
    // End of variables declaration//GEN-END:variables
}
